#!/usr/bin/venv python
import tensorflow as tf
import numpy as np
import roslib
roslib.load_manifest('joint_states_listener')
roslib.load_manifest('spider_control')
import pylab as plt
import math
from geometry_msgs.msgs import Pose, Point
import rospy, yaml, sys
from osrf_msgs.msg import JointCommands
from sensor_msgs.msg import JointState
from joint_states_listener.srv import *
import threading
import time
from std_msgs.msg import Float64
from sklearn.multiclass import OneVsRestClassifier
from sklearn.svm import LinearSVC

tf.enable_eager_execution()

class  LatestJointStates:


    def __init__(self):
        rospy.init_node('Joint state Listener')
        self.lock = threading.lock()
        self.name = []
        self.position = []
        self.velocity = []
        self.effort = []
        self.thread = threading.Thread(target=self.joint_States_listener)
        self.thread.start()

        s = rospy.Service('return_joint_states', ReturnJointStates, self.return_joint_states)
        #thread the function to listen to joint state messages
    def joint_states_listener(self):
        rospy.Subscriber('joint_states', JointState, self.joint_states_callback)
        rospy.spin()

        #callback function inorder to save the values when joint_states are available
    def joint_States_callback(self, msg):
        self.lock.acquire()
        self.name = msg.name
        self.position = msg.position
        self.velocity = msg.velocity
        self.effort = msg.effort
        self.lock.release()
        #function that returns joint variables for joint names that are given
    def return_joint_state(self, joint_name):

            #no messages
        if self.name==[]:
            rospy.logerr("no robot_State messages received \n")
            return 0, 0, 0, 0
            #return info for this joint
        self.lock.acquire()
        if joint_name in self.name:
            index = self.name.index(joint_name)
            position = self.position(index)
            velocity = self.velocity(index)
            effort = self.effort(index)

            #joint name not found
        else:
            rospy.logerr("Joint %s not found", (joint_name))
            self.lock.release()
            return 0, 0, 0, 0
        self.lock.release()
        return 1, position, velocity, effort
        #server callback to return array of position velocity and effort of the called joint names

    def return_joint_states(self, req):
        joints_found = []
        positions = []
        velocities = []
        efforts = []
        for joint_name in req.name:
            (found, position, velocity, effort)=self.return_joint_state(joint_name)
            joints_found.append(found)
            positions.append(position)
            velocities.append(velocity)
            efforts.append(effort)
        return ReturnJointStatesResponse(joints_found, positions, velocities, efforts)

def callback(msg):

            #log the message data
    rospy.loginfo(msg.data)
    return msg.data

def listener():
    rospy.init_node("tactile_listener")
    tactile_sub = rospy.Subscriber("/sr_tactile/touch/ff", Float64, callback)
    global tactile_1 #global variable to store tactile value for the leg 1
    global tactile_2 #global variable to store tactile value for the leg 2
    global tactile_3 #global variable to store tactile value for the leg 3
    global tactile_4 #global variable to store tactile value for the leg 4
    global tactile_5 #global variable to store tactile value for the leg 5
    global tactile_6 #global variable to store tactile value for the leg 6
    global tactile_7 #global variable to store tactile value for the leg 7
    global tactile_8 #global variable to store tactile value for the leg 8
    tactile_1 = tactile_sub[0]
    tactile_2 = tactile_sub[1]
    tactile_3 = tactile_sub[2]
    tactile_4 = tactile_sub[3]
    tactile_5 = tactile_sub[4]
    tactile_6 = tactile_sub[5]
    tactile_7 = tactile_sub[6]
    tactile_8 = tactile_sub[7]
    rospy.spin()
    return 0



def call_return_joint_states(joint_names):
    rospy.wait_for_service("return_joint_states")
    try:
        s = rospy.ServiceProxy("return_joint_States", ReturnJointStates)
        resp = s(joint_names)
    except rospy.ServiceException, e:
        print"error when calling return_joint_states: %s"%e
        sys.exit(1)
    for (ind, joint_name) in enumerate(joint_names):
        if(not resp.found[ind]):
            print"joint %s not found"%joint_name
    return (resp.position, resp.velocity, resp.effort)



class  Leg_attribute:
    m_l = 1  # mass of the link in every leg
    m_b = 4  # mass of the body
    x_b = 0
    y_b = 0
    l_1 = 4  # length of the links 1 and 2 of every leg
    l_3 = 6  # length of the link 3 from every leg i.e. distal joint
    r_1 = 2  # centre of gravity of links 1 and 2 from every leg
    r_3 = 3  # centre of gravity of links 3 from every leg i.e. distal link from distal joint
    radius = 0.5 #radius of the links
    global acc #acceleration at which the robot is supposed to move
    j_angles = np.ones((1, 3)) # in radians
    j_velocities = np.ones((1,3))
    j_efforts = np.ones((1, 3))
    bool  touch = False #variable to detect whether tactile sensor touch the ground or not
    def __init__(self, position1, position2, position3, velocity1, velocity2, velocity3, effort1, effort2, effort3, acceleration):
        self.j_angles[0] = position1  # vector containing the joint angles
        self.j_angles[1] = position2
        self.j_angles[2] = position3
        self.j_velocities[0] = velocity1  # vector containing joint velocities
        self.j_velocities[1] = velocity2
        self.j_velocities[2] = velocity3
        self.j_efforts[0] = effort1  # vector containing efforts of each joint in the leg
        self.j_efforts[1] = effort2
        self.j_efforts[2] = effort3
        self.acc = acceleration

    def give_angles(self):
        a = j_angles
        return a


    def set_touch(a):
        if a >= 1:
            touch  = True
        else:
            touch = False
        return

    def x_left_com(self, a, b, c, d, one_one, one_two, one_three, two_one, two_two, two_three, three_one, three_two, three_three, four_one, four_two, four_three, five_one, five_two, five_three, six_one, six_two, six_three, seven_one, seven_two, seven_three, eight_one, eight_two, eight_three):
        return (1/(2*(a+6*b)))*(a*d+2*b*c(3*(math.cos(one_three)+math.cos(three_three)+math.cos(five_three)+math.cos(seven_three))+2*(math.cos(one_two)+math.cos(three_two)+math.cos(five_two)+math.cos(seven_two))+math.cos(one_one)+math.cos(three_one)+math.cos(five_one)+math.cos(seven_one)))

   #a,b,c,d,e,f,j,k,l,m,n,o,p are respectively m_b,m_l,L,x_body_com/y_body_com,theta_1_1,theta_1_2,...theta_8_3

    def y_left_com(self, a, b, c, d,  one_one, one_two, one_three, two_one, two_two, two_three, three_one, three_two, three_three, four_one, four_two, four_three, five_one, five_two, five_three, six_one, six_two, six_three, seven_one, seven_two, seven_three, eight_one, eight_two, eight_three):
        return (1/(2*(a+6*b)))*(a*d+2*b*c(3*(math.sin(one_three)+3*math.sin(three_three)+math.sin(five_three)+math.sin(seven_three))+2*(math.sin(one_two)+math.sin(three_two)+math.sin(five_two)+math.sin(seven_two))+math.sin(one_one)+math.sin(three_one)+math.sin(five_one)+math.sin(seven_one)))

    def x_right_com(self, a, b, c, d, one_one, one_two, one_three, two_one, two_two, two_three, three_one, three_two, three_three, four_one, four_two, four_three, five_one, five_two, five_three, six_one, six_two, six_three, seven_one, seven_two, seven_three, eight_one, eight_two, eight_three):
        return (1/(2*(a+6*b)))*(3*a*d+2*b*c*(3*math.cos(two_three)+3*math.cos(four_three)+3*math.cos(six_three)+3*math.cos(eight_three)+2*math.cos(two_two)+2*math.cos(four_two)+2*math.cos(six_two)+2*math.cos(eight_two)+math.cos(two_one)+math.cos(four_one)+math.cos(six_one)+math.cos(eight_one)))

    def y_right_com(self, a, b, c, d, one_one, one_two, one_three, two_one, two_two, two_three, three_one, three_two, three_three, four_one, four_two, four_three, five_one, five_two, five_three, six_one, six_two, six_three, seven_one, seven_two, seven_three, eight_one, eight_two, eight_three):
        return (1/(2*(a+6*b)))*(3*a*d+2*b*c*(3*math.sin(two_three)+3*math.sin(four_three)+3*math.sin(six_three)+3*math.sin(eight_three)+2*math.sin(two_two)+2*math.sin(four_two)+2*math.sin(six_two)+2*math.sin(eight_two)+math.sin(two_one)+math.sin(four_one)+math.sin(six_one)+math.sin(eight_one)))

    def x_system_com(self, a, b, c, d, one_one, one_two, one_three, two_one, two_two, two_three, three_one, three_two, three_three, four_one, four_two, four_three, five_one, five_two, five_three, six_one, six_two, six_three, seven_one, seven_two, seven_three, eight_one, eight_two, eight_three):
        return  (1/(a+6*b*c))*(2*a*d+b*c*(3*(math.cos(one_three)+math.cos(two_three)+math.cos(three_three)+math.cos(four_three)+math.cos(five_three)+math.cos(six_three)+math.cos(seven_three)+math.cos(eight_three))+2*(math.cos(one_two)+math.cos(two_two)+math.cos(three_two)+math.cos(four_two)+math.cos(five_two)+math.cos(six_two)+math.cos(seven_two)+math.cos(eight_two))+math.cos(one_one)+math.cos(two_one)+math.cos(three_one)+math.cos(four_one)+math.cos(five_one)+math.cos(six_one)+math.cos(seven_one)+math.cos(eight_one)))

    def y_system_com(self, a, b, c, d, one_one, one_two, one_three, two_one, two_two, two_three, three_one, three_two, three_three, four_onr, four_two, four_three, five_one, five_two, five_three, six_one, six_two, six_three, seven_one, seven_two, seven_three, eight_one, eight_two, eight_three):
        return  (1/(a+6*b*c))*(2*a*d+b*c*(3*(math.sin(one_three)+math.sin(two_three)+math.sin(three_three)+math.sin(four_three)+math.sin(five_three)+math.sin(six_three)+math.sin(seven_three)+math.sin(eight_three))+2*(math.sin(one_two)+math.sin(two_two)+math.sin(three_two)+math.sin(four_two)+math.sin(five_two)+math.sin(six_two)+math.sin(seven_two)+math.sin(eight_two))+math.sin(one_one)+math.sin(two_one)+math.sin(three_one)+math.sin(four_one)+math.sin(five_one)+math.sin(six_one)+math.sin(seven_one)+math.sin(eight_one)))

    def mid_point_x(self, x_left, x_right):
        'in order to calculate whether the syste com is normal to the line between left and right com'
        x_mid = (x_right - x_left)/2
        return x_mid

    def mid_point_y(self, y_left, y_right):
        'in order to calculate whether the system com is normal to the line between left and right com'
        y_mid = (y_right - y_left)/2
        return y_mid

    def slope(self, x_mid, y_mid, x_system, y_system):
        'slope to measure the balance of the robot that can be used to define reward or punishment'
        m = (y_system - y_mid)/(x_system - x_mid)
        m_radian = (m*3.14)/180
        return m_radian

    #calculates carolis term for each leg
    def carolis_term(self, m_l, r_1, l_1, j_angles[], j_velocities[], acc):
        term_1 = acc*(m_l*9.8*j_velocities[0]*(r_1*math.sin(j_angles[0])+2*l_1*math.sin(j_angles[0])+r_1*math.sin(j_angles[0]+j_angles[1])+r_1*math.sin(j_angles[0]+j_angles[1]+j_angles[2]))+m_l*9.8*j_velocities[1]*(r_1*math.sin(j_angles[0]+j_angles[1])+l_1*math.sin(j_angles[1])+r_1*math.sin(j_angles[0]+j_angles[1]+j_angles[2]))+m_l*9.8*j_velocities[2]*(r_1*math.sin(j_angles[0]+j_angles[1]+j_angles[2])))
        term_2 = acc*(m_l*9.8*j_velocities[0]*(r_1*math.sin(j_angles[0]+j_angles[1])+r_1*math.sin(j_angles[0]+j_angles[1]+j_angles[2]))+m_l*9.8*j_velocities[1]*(r_1*math.sin(j_angles[0]+j_angles[1])+l_1*math.sin(j_angles[1])+r_1*math.sin(j_angles[0]+j_angles[1]+j_angles[2]))+m_l*9.8*j_velocities[2]*math.sin(j_angles[0]+j_angles[1]+j_angles[2]))
        term_3 = acc*(m_l*9.8*j_velocities[0]*math.sin(j_angles[0]+j_angles[1]+j_angles[2])+m_l*9.8*j_velocities[1]*math.sin(j_angles[0]+j_angles[1]+j_angles[2])+m_l*9.8*j_velocities[2]*math.sin(j_angles[0]+j_angles[1]+j_angles[2]))
        term = term_1 +term_2 + term_3
        return term

















class  Architecture:
    'Common class defining the architecture of the neural network i.e. number of neurons in each layer and number of layers'

    def __init__(self, layers, neurons):
        self.layers = layers
        self.neurons = neurons
        #global neuron_i
        #global neuron_o
        #global neuron_h
        #global neuron_h_c
        #global weights_i
        #global weights_o
        #global weights_h
        #global weights_h_c
        #global bias_i
        #global bias_o
        #global bias_h
        #global bias_h_c
        self.neuron_i = tf.placeholder(tf.float32, shape=(neurons, 1))  # _input layer neurons
        self.neuron_o = tf.placeholder(tf.float32, shape=(neurons, 1))  # output layer neurons
        self.neuron_h = tf.placeholder(tf.float32, shape=(neurons/3, 1))  # hidden layer neurons, only 8 neurons because there are eight legs
        self.neuron_h_c = tf.placeholder(tf.float32, shape=(neurons/3, 1))  # context layer neurons, only 8 neurons because there are eight in hidden layer
        self.weights_i = tf.placeholder(tf.float32, shape=(neurons, layers))  # weights of input layer neurons
        self.weights_o = tf.placeholder(tf.float32, shape=(neurons, layers))  # weights of output layer neurons
        self.weights_h = tf.placeholder(tf.float32, shape=(neurons/3, layers))  # weights of hidden layer neurons
        self.weights_h_c = tf.placeholder(tf.float32, shape=(neurons/3, layers))  # weights of context layer neurons
        self.bias_i = tf.random_uniform((neurons, 1), minval = 0, maxval = 1, dtype = tf.float32, seed=9999) #biases of each neurons
        self.bias_o = tf.random_uniform((neurons, 1), minval = 0, maxval = 1, dtype = tf.float32, seed = 1111)
        self.bias_h = tf.random_uniform((neurons/3, 1), minval = 0, maxval = 1, dtype = tf.float32, seed=2222)
        self.bias_h_c = tf.random_uniform((neurons/3, 1), minval = 0, maxval = 1, dtype = tf.float32, seed=3333)

    def weight_initialize (self, neurons):
        weights1 = tf.Variable(tf.random_uniform((neurons, 1), minval=0, maxval=1, dtype=tf.float32, seed=7273))
        weights2 = tf.Variable(tf.random_uniform((neurons, 1), minval=0, maxval=1, dtype=tf.float32, seed=3000))
        weights3h=tf.Variable(tf.random_uniform((neurons/3, neurons/6), minval=0, maxval=1, dtype=tf.float32, seed=0119))
        weights3c=tf.Variable(tf.random_uniform((neurons/3, 1), minval=0, maxval=1, dtype=tf.float32, seed=1508))
        sess=tf.Session()
        weights_i, weights_o, weights_h, weights_h_c = sess.run(weights1, weights2, weights3h, weights3c)
        return (weights_i, weights_o, weights_h, weights_h_c)

    # get neuron value method helps us to write the joint angles to the individual neurons which we can later use for learning
    def get_neuron_value(self, a, b):
        with tf.Session() as sess_n:
            sess_n.run(a, feed_dict={a: b})
        return

    def input_method(self, neurons = [], weights = [], bias = []):
        'input function of the main neural network'
        multi = tf.matmul(neurons, weights, transpose_a = tf.false, transpose_b=tf.false)
        add1 = tf.add(multi, bias)
        ses = tf.Session()
        neuron_input = ses.run(add1)
        return neuron_input

    def transfer_function(self, a = []):
        b = tf.nn.softmax(a, name='sigmoid')
        '0.5 being the threshold that is required to activate the neuron'
        if (b >= 0.5):
            out = b*a
        else:
            out = 0
        return out

    def NN_learningPunishment(self, LearningRate, punishment):
        'a method to minimize the rewards and alot the weights based on that'
        init1 = tf.global_variables_initializer()
        with tf.Session as session1:
            session1.run(init1)
        optimizer = tf.train.GradientDescentOptimizer(LearningRate).minimize(punishment)
        with tf.Session as sess:
            sess.run(optimizer)
        return

    def NN_learningReward(self, LearningRate, reward):
        'a method to maximize reward and alot the weights based on that'
        init1 = tf.global_variables_initializer()
        with tf.Session as sess:
            sess.run(init1)
        optimizer = tf.train.GradientDescentOptimizer(LearningRate).minimize((-1*reward))
        with tf.Session as session:
            session.run(optimizer)

    def output_function(self, a = []):
        b = tf.nn.softmax(a, name='sigmoid')
        out = b*a
        return out





 #class that describes multi class logistic regression for knowledge transfer
class MultiClassLogistic:

    def __init__(self, neurons, neuron_values, layers):
        self.neurons = neurons
        self.layers =  layers
        global weight_in, weight_hid, weight_out, bias_hid, bias_in, bias_out
        self.weight_in = weight_in
        self.weight_hid = weight_hid
        self.weight_out = weight_out
        self.bias_hid = bias_hid
        self.bias_out = bias_out
        self.bias_in = bias_in

        self.neuron_input = np.array(neuron_values)#assigning input values to neurons
        self.neuron_hidden = np.array(4, 1)#an array to assign neuron values of hidden layer
        self.neuron_out = np.array(3, 1)#an array to assign neuron values of output layer
        weights1 = tf.Variable(tf.random_normal((neurons, 1), dtype=tf.float32, seed=1606))#weights of input layer
        weights2 = tf.Variable(tf.random_normal((neurons/2, neurons/2), dtype=tf.float32, seed=1003))#weights for hidden layer, number of neurons in hidden layer is identified by the quadrant concept
        weights3 = tf.Variable(tf.random_normal((3, 1), dtype=tf.float32, seed=0207))#weights for output layer
        bias_in  =tf.random_normal((neurons, 1), dtype = tf.float32, seed = 2009)
        bias_hid = tf.random_normal((neurons/2, 1), dtype = tf.float32, seed = 2509)
        bias_out = tf.random_normal((3, 1), dtype=tf.float32, seed = 1234)
        sess = tf.Session()
        weight_in, weight_hid, weight_out, bias_in, bias_hid, bias_out = sess.run(weights1, weights2, weights3, bias_in, bias_hid, bias_out)

    #defining input function that can accept the output from previous layer and can calculate the input for present layer

    def input_function(self, a = [], b = [], c = []):
        'where b=output value of neurons from previous layer, a = weights of neurons from the present layer, c = bias'
        multiplication = tf.matmul(a, b)
        add  = tf.add(multiplication, c)
        sess = tf.Session()
        n_input = sess.run(add)
        return n_input
    #function that returns the softmax of the output layer or any given array of neurons
    def out_softmax(self, neuron_out = []):
        output = np.array(3)
        output = tf.nn.softmax(neuron_out)
        return output

    def output_func(self, ):

    def activation(self, a):
        'where a is the input of the neuron and the activation function is modelled as rectified linear output'
        if(a>=0):
            b = a
        else:
            b = 0
        return b
    def kt_learning(self, learning_rate, n_out = [], n_preferred = []):
        'where n_out is the actual output and n_preffered is the prefered output of the network'
        init = tf.global_variables_initializer()
        with tf.Session as session:
            session.run(init)
        loss = tf.reduce_mean(tf.nn.softmax_cross_entropy_with_logits(labels=n_out, logits=n_preferred))
        optimizer = tf.train.GradientDescentOptimizer(learning_rate).minimize(loss)
        with tf.Session() as sess:
            sess.run(optimizer)
        return










    #function to normalize the input data
def normalization(a = []):
    a_min = min(a)
    a_max = max(a)
    for i in range(len(a)):
        a[i] = (a[i]-a_min)/(a_max-a_min)
    return

def one_hot_encoding( iteration_time, model_type):
    a = np.zeros(2, 1)
    if (model_type == 1):
        hot_encoded_matrix = np.insert(a, 0, 1, axis=0)
    elif(model_type == 2):
        hot_encoded_matrix = np.insert(a, 1, 1, axis=0)
    elif(model_type == 3):
        hot_encoded_matrix = np.append(a, [1])
    else:
        print("please enter a valid model number")
    return hot_encoded_matrix


if __name__=="__main__":
    spiderJoint1Names = ['spider::joint_1_1', 'spider::joint_1_2', 'spider::joint_1_3']
    spiderJoint2Names = ['spider::joint_2_1', 'spider::joint_2_2', 'spider::joint_2_3']
    spiderJoint3Names = ['spider::joint_3_1', 'spider::joint_3_2', 'spider::joint_3_3']
    spiderJoint4Names = ['spider::joint_4_1', 'spider::joint_4_2', 'spider::joint_4_3']
    spiderJoint5Names = ['spider::joint_5_1', 'spider::joint_5_2', 'spider::joint_5_3']
    spiderJoint6Names = ['spider::joint_6_1', 'spider::joint_6_2', 'spider::joint_6_3']
    spiderJoint7Names = ['spider::joint_7_1', 'spider::joint_7_2', 'spider::joint_7_3']
    spiderJoint8Names = ['spider::joint_8_1', 'spider::joint_8_2', 'spider::joint_8_3']
    model_1 = Architecture(3, 24) #for model one of the terrain
    model_2 = Architecture(3, 24) #for model two of the terrain
    model_3 = Architecture(3, 24) #for model three of the terrain
    run_method = raw_input("How do you want to run the algorithm ? for training, type train. for testing, type test")
    global run_time
    global model_trained
    run_time_time = raw_input("please enter how long you intend to run the robot")
    if ( run_method == 'train'):
        training_time = raw_input("please enter how long you intend to train the algorithm")
        run_time = training_time
        model_trained = raw_input("which model do you want to train ?, please enter model_number for straight terrain select 1, for accute angled terrain select 2, for obtuse angled terrain select 3")
        while run_time:



    elif ( run_method == 'test'):
        run_time = 1
    rospy.spin()
    joint_angles_input = np.array(24)
    output_layerhidcont = np.zeros(8, 1)
    while run_time:

        for spiderJoint1Name in spiderJoint1Names:
            (position, velocity, effort) = call_return_joint_states(spiderJoint1Name)
            leg1 = Leg_attribute(position, velocity, effort)

        for spiderJoint2Name in spiderJoint2Names:
            (position, velocity, effort) = call_return_joint_states(spiderJoint2Name)
            leg2 = Leg_attribute(position, velocity, effort)

        for spiderJoint3Name in spiderJoint3Names:
            (position, velocity, effort) = call_return_joint_states(spiderJoint3Name)
            leg3 = Leg_attribute(position, velocity, effort)

        for spiderJoint4Name in spiderJoint4Names:
            (position, velocity, effort) = call_return_joint_states(spiderJoint4Name)
            leg4 = Leg_attribute(position, velocity, effort)

        for spiderJoint5Name in spiderJoint5Names:
            (position, velocity, effort) = call_return_joint_states(spiderJoint5Name)
            leg5 = Leg_attribute(position, velocity, effort)

        for spiderJoint6Name in spiderJoint6Names:
            (position, velocity, effort) = call_return_joint_states(spiderJoint6Name)
            leg6 = Leg_attribute(position, velocity, effort)

        for spiderJoint7Name in spiderJoint7Names:
            (position, velocity, effort) = call_return_joint_states(spiderJoint7Name)
            leg7 = Leg_attribute(position, velocity, effort)

        for spiderJoint8Name in spiderJoint8Names:
            (position, velocity, effort) = call_return_joint_states(spiderJoint8Name)
            leg8 = Leg_attribute(position, velocity, effort)

        listener()
        leg1.set_touch(tactile_1)
        leg2.set_touch(tactile_2)
        leg3.set_touch(tactile_3)
        leg4.set_touch(tactile_4)
        leg5.set_touch(tactile_5)
        leg6.set_touch(tactile_6)
        leg7.set_touch(tactile_7)
        leg8.set_touch(tactile_8)
        joint_angle_leg_1 = leg1.give_angles() #writing the angles from each leg to a saperate array variable
        joint_angle_leg_2 = leg2.give_angles()
        joint_angle_leg_3 = leg3.give_angles()
        joint_angle_leg_4 = leg4.give_angles()
        joint_angle_leg_5 = leg5.give_angles()
        joint_angle_leg_6 = leg6.give_angles()
        joint_angle_leg_7 = leg7.give_angles()
        joint_angle_leg_8 = leg8.give_angles()
        joint_angles_input = np.concatenate(joint_angle_leg_1, joint_angle_leg_2, joint_angle_leg_3, joint_angle_leg_4, joint_angle_leg_5, joint_angle_leg_6, joint_angle_leg_7, joint_angle_leg_8)
        joint_angle_input = joint_angle_input.reshape(24, 1)#combined all the input angles into a single coloumn vector for a neural network
        model_1.get_neuron_value(model_1.neuron_i, joint_angle_input) #feeding the input angles into the input layer of the neural network
        output_layer1 = np.array(24)
        input_layerhid = np.array(8)
        output_layerhid = np.array(8)
        input_layerhidcont = np.array(8)
        output_layerhidcont = np.array(8)
        input_layerout = np.array(24)
        output_layerout  =np.array(24)
        for i in range(0, 24, 1):
            output_layer1[i] = model_1.input_method(model_1.neuron_i[i, :], weight_in[:, i])#finding the ouput of the input layer
        for j in range(0, 8, 1):
            output_layerh =  output_layer1[0, 3*j:3*j+3]
            output_layerh.append(output_layerhidcont[j])#adding output from context layer from previous iteration as input for hidden layer
            input_layerhid[j] = model_1.input_method(output_layer1, model_1.weights_i[j, :])
        model_1.get_neuron_value(model_1.neuron_h, input_layerhid)# feeding the neuron value of hidden layer
        output_layerhid = model_1.transfer_function(model_1.neuron_h)
        for i in range(0, 8, 1):
            input_layerhidcont[i] = model_1.input_method(output_layerhid[i],model_1.weights_h_c[i])#input function for hidden context layer, context layr only has one input to each neuron and one weight associated to each neuron
        model_1.get_neuron_value(model_1.neuron_h_c, input_layerhidcont)#passing the input to the hidden context
        output_layerhidcont = model_1.transfer_frunction(model_1.neuron_h_c)#output of the neurons from context layer
        input_layerout = tf.multiply(output_layerhid, model_1.weights_o[0:8])
        input_layerout.append(tf.multiple(output_layerhid, model_1.weights_o[8:16]))
        input_layerout.append(tf.multiply(output_layerhid, model_1.weights_o[16:24]))#element wise multiplication
        model_1.get_neuron_value(model_1.neuron_o, input_layerout)
        output_layerout = model_1.output_function(model_1.neuron_o)#output of the neural network for model 1 that is to be feeded to the robot
        x_left_com = Leg_attribute.x_left_com(leg1.m_l, g, leg1.r_1, leg1.l_1, joint_angle_leg_1[0], joint_angle_leg_1[1], joint_angle_leg_1[2], joint_angle_leg_2[0], joint_angle_leg_2[1], joint_angle_leg_2[2], joint_angle_leg_3[0], joint_angle_leg_3[1], joint_angle_leg_3[2], joint_angle_leg_4[0], joint_angle_leg_4[1], joint_angle_leg_4[2], joint_angle_leg_5[0], joint_angle_leg_5[1], joint_angle_leg_5[2], joint_angle_leg_6[0], joint_angle_leg_6[1], joint_angle_leg_6[2], joint_angle_leg_7[0], joint_angle_leg_7[1], joint_angle_leg_7[2], joint_angle_leg_8[0], joint_angle_leg_8[1], joint_angle_leg_8[2])
        y_left_com = Leg_attribute.y_left_com(leg1.m_l, g, leg1.r_1, leg1.l_1, joint_angle_leg_1[0], joint_angle_leg_1[1], joint_angle_leg_1[2], joint_angle_leg_2[0], joint_angle_leg_2[1], joint_angle_leg_2[2], joint_angle_leg_3[0], joint_angle_leg_3[1], joint_angle_leg_3[2], joint_angle_leg_4[0], joint_angle_leg_4[1], joint_angle_leg_4[2], joint_angle_leg_5[0], joint_angle_leg_5[1], joint_angle_leg_5[2], joint_angle_leg_6[0], joint_angle_leg_6[1], joint_angle_leg_6[2], joint_angle_leg_7[0], joint_angle_leg_7[1], joint_angle_leg_7[2], joint_angle_leg_8[0], joint_angle_leg_8[1], joint_angle_leg_8[2])
        x_right_com = Leg_attribute.x_right_com(leg1.m_l, g, leg1.r_1, leg1.l_1, joint_angle_leg_1[0], joint_angle_leg_1[1], joint_angle_leg_1[2], joint_angle_leg_2[0], joint_angle_leg_2[1], joint_angle_leg_2[2], joint_angle_leg_3[0], joint_angle_leg_3[1], joint_angle_leg_3[2], joint_angle_leg_4[0], joint_angle_leg_4[1], joint_angle_leg_4[2], joint_angle_leg_5[0], joint_angle_leg_5[1], joint_angle_leg_5[2], joint_angle_leg_6[0], joint_angle_leg_6[1], joint_angle_leg_6[2], joint_angle_leg_7[0], joint_angle_leg_7[1], joint_angle_leg_7[2], joint_angle_leg_8[0], joint_angle_leg_8[1], joint_angle_leg_8[2])
        y_right_com = Leg_attribute.y_right_com(leg1.m_l, g, leg1.r_1, leg1.l_1, joint_angle_leg_1[0], joint_angle_leg_1[1], joint_angle_leg_1[2], joint_angle_leg_2[0], joint_angle_leg_2[1], joint_angle_leg_2[2], joint_angle_leg_3[0], joint_angle_leg_3[1], joint_angle_leg_3[2], joint_angle_leg_4[0], joint_angle_leg_4[1], joint_angle_leg_4[2], joint_angle_leg_5[0], joint_angle_leg_5[1], joint_angle_leg_5[2], joint_angle_leg_6[0], joint_angle_leg_6[1], joint_angle_leg_6[2], joint_angle_leg_7[0], joint_angle_leg_7[1], joint_angle_leg_7[2], joint_angle_leg_8[0], joint_angle_leg_8[1], joint_angle_leg_8[2])
        x_system_com = Leg_attribute.x_system_com(leg1.m_l, g, leg1.r_1, leg1.l_1, joint_angle_leg_1[0], joint_angle_leg_1[1], joint_angle_leg_1[2], joint_angle_leg_2[0], joint_angle_leg_2[1], joint_angle_leg_2[2], joint_angle_leg_3[0], joint_angle_leg_3[1], joint_angle_leg_3[2], joint_angle_leg_4[0], joint_angle_leg_4[1], joint_angle_leg_4[2], joint_angle_leg_5[0], joint_angle_leg_5[1], joint_angle_leg_5[2], joint_angle_leg_6[0], joint_angle_leg_6[1], joint_angle_leg_6[2], joint_angle_leg_7[0], joint_angle_leg_7[1], joint_angle_leg_7[2], joint_angle_leg_8[0], joint_angle_leg_8[1], joint_angle_leg_8[2])
        y_system_com = Leg_attribute.y_system_com(leg1.m_l, g, leg1.r_1, leg1.l_1, joint_angle_leg_1[0], joint_angle_leg_1[1], joint_angle_leg_1[2], joint_angle_leg_2[0], joint_angle_leg_2[1], joint_angle_leg_2[2], joint_angle_leg_3[0], joint_angle_leg_3[1], joint_angle_leg_3[2], joint_angle_leg_4[0], joint_angle_leg_4[1], joint_angle_leg_4[2], joint_angle_leg_5[0], joint_angle_leg_5[1], joint_angle_leg_5[2], joint_angle_leg_6[0], joint_angle_leg_6[1], joint_angle_leg_6[2], joint_angle_leg_7[0], joint_angle_leg_7[1], joint_angle_leg_7[2], joint_angle_leg_8[0], joint_angle_leg_8[1], joint_angle_leg_8[2])
        x_mid_com = Leg_attribute.mid_point_x(x_left_com, x_right_com)
        y_mid_com = Leg_attribute.mid_point_y(y_left_com, y_right_com)
        reward = Leg_attribute.slope(x_mid_com, y_mid_com, x_system_com, y_system_com)
        Learningrate = 0.1
        model_1.NN_learningReward(Learningrate, reward)
        leg1_carollis = leg1.carolis_term(leg1.m_l, leg1.r_1, leg1.l_1, joint_angle_leg_1)
        leg2_carollis = leg2.carolis_term(leg2.m_1, leg2.r_1, leg2.l_1, joint_angle_leg_2)
        leg3_carollis = leg3.carolis_term(leg3.m_1, leg3.r_1, leg3.l_1, joint_angle_leg_3)
        leg4.carollis = leg4.carolis_term(leg4.m_1, leg4.r_1, leg4.l_1, joint_angle_leg_4)
        leg5.carollis = leg5.carolis_term(leg5.m_1, leg5.r_1, leg5.l_1, joint_angle_leg_5)
        leg6_carollis = leg6.carolis_term(leg6.m_1, leg6.r_1, leg6.l_1, joint_angle_leg_6)
        leg7_carollis = leg7.carolis_term(leg7.m_1, leg7.r_1, leg7.l_1, joint_angle_leg_7)
        leg8_carollis = leg8.carolis_term(leg8.m_1, leg8.r_1, leg8.l_1, joint_angle_leg_8)

        #NN for model 2

        #calculating carolis term to find classifier for KT
        carolis_term_leg1 = Leg_attribute.carolis_term(leg1.m_l, 9.8, leg1.r_1, leg1.l_1, joint_angle_leg_1)
        carolis_term_leg2 = Leg_attribute.carolis_term(leg2.m_l, 9.8, leg2.r_1, leg2.l_1, joint_angle_leg_2)
        carolis_term_leg3 = Leg_attribute.carolis_term(leg3.m_l, 9.8, leg3.r_1, leg3.l_1, joint_angle_leg_3)
        carolis_term_leg4 = Leg_attribute.carolis_term(leg4.m_l, 9.8, leg4.r_1, leg4.l_1, joint_angle_leg_4)
        carolis_term_leg5 = Leg_attribute.carolis_term(leg5.m_l, 9.8, leg5.r_1, leg5.l_1, joint_angle_leg_5)
        carolis_term_leg6 = Leg_attribute.carolis_term(leg6.m_l, 9.8, leg5.r_1, leg5.l_1, joint_angle_leg_6)
        carolis_term_leg7 = Leg_attribute.carolis_term(leg7.m_l, 9.8, leg7.r_1, leg7.l_1, joint_angle_leg_7)
        carolis_term_leg8 = Leg_attribute.carolis_term(leg8.m_l, 9.8, leg8.r_1, leg8.l_1, joint_angle_leg_8)
        net_carolis = carolis_term_leg1+carolis_term_leg2+carolis_term_leg3+carolis_term_leg4+carolis_term_leg5+carolis_term_leg6+carolis_term_leg7+carolis_term_leg8
        #making a y value to plot hyperplane
        y_model = np.ones((1, run_time))
        joint_angles_input = np.arange(24)
        j1 = 0 #variable used to write joint angles of leg into input array
        for i in range (0, 3, 1):
            if(j1<3):
                joint_angles_input[i] = joint_angle_leg_1[j1]
                j1 = j1+1
        j2 = 0 #variable used to write joint angles of leg into input array
        for i in range (3, 6, 1):
            if(j2<3):
                joint_angles_input[i] = joint_angle_leg_2[j2]
                j2 = j2+1
        j3 = 0 #variable used to write joint angles of leg into input array
        for i in range (6, 9, 1):
            if(j3<3):
                joint_angles_input[i] = joint_angle_leg_3[j3]
                j3 = j3+1
        j4 = 0 #variable used to write joint angles of leg into input array
        for i in range (9, 12, 1):
            if(j4<3):
                joint_angles_input[i] = joint_angle_leg_4[j4]
                j4 = j4+1
        j5 = 0 #variable used to write joint angle of leg into input array
        for i in range (12, 15, 1):
            if(j5<3):
                joint_angles_input[i] = joint_angle_leg_5[j5]
                j5 = j5+1
        j6 = 0 #variable used to write joint angles of leg into input array
        for i in range (15, 18, 1):
            if(j6<3):
                joint_angles_input[i] = joint_angle_leg_6[j6]
                j6 = j6+1
        j7 = 0 #variable usd to write joint angles of leg into input array
        for i in range (18, 21, 1):
            if(j7<3):
                joint_angles_input[i] = joint_angle_leg_7[j7]
                j7 = j7+1

        j8 = 0 #variable used to write joint angles of leg into input array
        for i in range(21, 24, 1):
            if(j8<3):
                joint_angles_input[i] = joint_angle_leg_8[j8]
                j8 = j8+1
















